package projet.iut.jeu_de_la_vie.launcher;

import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.constraintlayout.widget.ConstraintLayout;
import androidx.constraintlayout.widget.ConstraintSet;

import java.awt.font.NumericShaper;
import java.util.List;

import projet.iut.jeu_de_la_vie.R;
import projet.iut.jeu_de_la_vie.model.FragmentPlateau;
import projet.iut.jeu_de_la_vie.model.Manager;
import projet.iut.jeu_de_la_vie.model.cellule.Cellule;
import projet.iut.jeu_de_la_vie.model.plateau.Plateau;

public class Launcher extends AppCompatActivity {

    private Manager manager;
    private Button start;

    @Override
    protected void onResume(){
        super.onResume();
    }


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        manager = new Manager();
        setContentView(R.layout.jeu_de_la_vie);
        /*
        //très moche à enlever plus tard
        start = findViewById(R.id.startButton);
        //manager.lancerJeu();
        start.setOnClickListener(l -> {
            EditText colones = findViewById(R.id.nbColone);
            //manager.getActualiseurCellule().getArbitre().getPlateau().setColone(Integer.parseInt(colones.getText().toString()));
            EditText lignes = findViewById(R.id.nbLignes);
            //manager.getActualiseurCellule().getArbitre().getPlateau().setLigne(Integer.parseInt(lignes.getText().toString()));
            for (List<Cellule> list : manager.getActualiseurCellule().getArbitre().getPlateau().getGrille()) {
                for (Cellule cell :  list) {
                    Log.d("instances",cell.isAlive().toString());
                }
            }
            manager.lancerJeu();
            manager.update();
        });
        findViewById(R.id.test).setOnClickListener(y -> {
            manager.getActualiseurCellule().getArbitre().getPlateau().setColone(2);
            manager.getActualiseurCellule().getArbitre().getPlateau().setLigne(2);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(1, 1).setAlive(true);
            //manager.getActualiseurCellule().getArbitre().getPlateau().getCell(0, 0).setAlive(true);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(1, 0).setAlive(true);
            manager.getActualiseurCellule().getArbitre().getPlateau().getCell(0, 1).setAlive(true);
        });
        */
        getSupportFragmentManager().beginTransaction().add(R.id.fragmentContainerView,FragmentPlateau.class,null).commit();
        FragmentPlateau frag = new FragmentPlateau();
        getSupportFragmentManager().putFragment(new Bundle(),"main",frag);
        manager.setFragmentPlateau(frag);
    }

    public void updateGame (){

    }

    @Override
    protected void onStart (){
        super.onStart();
        FragmentPlateau fragment = new FragmentPlateau();
        fragment.setPlateau(manager.getActualiseurCellule().getArbitre().getPlateau());
    }

    @Override
    protected void onStop() {

        super.onStop();
    }

    private void setNbColumns(){
        //EditText editText = findViewById(R.id.nbColone);
        //Editable text = editText.getText();
        //manager.setNumberOfColumns(Integer.parseInt(text.toString()));
    }
    private void setNbLignes(){
        EditText editText = findViewById(R.id.nbLignes);
        Editable text = editText.getText();
        manager.setNumberOfLines(Integer.parseInt(text.toString()));
    }
    private void setCellsColor(int color){
        manager.setCellsColor(color);
    }

    public void startGame(View view){
        setNbLignes();
        setNbColumns();
        Log.d("d", "" + manager.getActualiseurCellule().getArbitre().getPlateau().getColone());
        Log.d("d", "" + manager.getActualiseurCellule().getArbitre().getPlateau().getLigne());
        Log.d("d", "" + Cellule.getLivingColor());
    }
    public void setCellsRed(View view){
        int red = Color.RED;
        setCellsColor(red);
    }
    public void setCellsGreen(View view){
        int green = Color.GREEN;
        setCellsColor(green);
    }
    public void setCellsBlue(View view){
        int blue = Color.BLUE;
        setCellsColor(blue);
    }

    @Override
    protected void onSaveInstanceState(@NonNull Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putSerializable("manager",manager); //c'est bourrin mais magique
    }

    @Override
    protected void onRestoreInstanceState(@NonNull Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        manager = (Manager) savedInstanceState.getSerializable("manager");
    }

}
